## socket-wrapper 1.1.3

=== CMakeLists.txt ===
project(socket_wrapper C)

# Required cmake version
cmake_minimum_required(VERSION 2.8.5)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "1")
set(APPLICATION_VERSION_PATCH "3")

set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")

# SOVERSION scheme: CURRENT.AGE.REVISION
#   If there was an incompatible interface change:
#     Increment CURRENT. Set AGE and REVISION to 0
#   If there was a compatible interface change:
#     Increment AGE. Set REVISION to 0
#   If the source code was changed, but there were no interface changes:
#     Increment REVISION.
set(LIBRARY_VERSION "0.1.3")
set(LIBRARY_SOVERSION "0")

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefinePlatformDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions.cmake)
include(CPackConfig.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)

if (UNIT_TESTING)
    find_package(cmocka 0.4.1 REQUIRED)

    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# pkg-config file
get_filename_component(SOCKET_WRAPPER_LIB ${SOCKET_WRAPPER_LOCATION} NAME)

configure_file(socket_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc
  DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
configure_file(socket_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake @ONLY)
configure_file(socket_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_DIR}/socket_wrapper
    COMPONENT
        devel
)

add_subdirectory(doc)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMOCKA_INCLUDE_DIR}
)

set(TORTURE_LIBRARY torture)

# RFC862 echo server
add_executable(echo_srv echo_srv.c)
target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})

add_library(${TORTURE_LIBRARY} STATIC torture.c)
target_link_libraries(${TORTURE_LIBRARY}
    ${CMOCKA_LIBRARY}
    ${SWRAP_REQUIRED_LIBRARIES})

set(SWRAP_TESTS
    test_ioctl
    test_echo_tcp_socket
    test_echo_tcp_connect
    test_echo_tcp_bind
    test_echo_tcp_socket_options
    test_echo_tcp_write_read
    test_echo_tcp_writev_readv
    test_echo_tcp_get_peer_sock_name
    test_echo_udp_sendto_recvfrom
    test_echo_udp_send_recv
    test_echo_udp_sendmsg_recvmsg)

if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)
endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)

foreach(_SWRAP_TEST ${SWRAP_TESTS})
    add_cmocka_test(${_SWRAP_TEST} ${_SWRAP_TEST}.c ${TORTURE_LIBRARY})

    if (OSX)
        set_property(
            TEST
                ${_SWRAP_TEST}
            PROPERTY
                ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION})
    else ()
        set_property(
            TEST
                ${_SWRAP_TEST}
            PROPERTY
                ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION})
    endif()
endforeach()

=== debian/changelog ===
socket-wrapper (1.1.3-2) unstable; urgency=low

  * Define PATH_MAX on Hurd.
  * Wait more for test_srv during tests (closes: #787572).
  * Make watch file more generic.
  * Update debhelper level to 9 .
  * Upload to unstable.
  * New maintainer (closes: #770374).

  [ Jakub Wilk <jwilk@debian.org> ]
  * Add patch (reproducible-manpage.diff) to make the builds reproducible
    (closes: #782863). Thanks to Jelmer Vernooij for the bug report and the
    patch.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 04 Jun 2015 20:02:03 +0000

socket-wrapper (1.1.3-1) experimental; urgency=low

  * New upstream release:
    + Add support for address sanitizer.
    + Fix leaking of memory and fds of stale sockets.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 24 Feb 2015 22:31:00 +0100

socket-wrapper (1.1.2-1) experimental; urgency=low

  * New upstream release:
    + Add support for fnctl(F_DUPFD).
    + Add support for glibc 2.20.90.
  * Rebuild the nss_wrapper manpage from source:
    + Add asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl to
      Build-Depends.
    + Add the manpage to extend-diff-ignore in debian/source/options.
    + Run a2x in debian/rules.
  * Bump standards version to 3.9.6 (no changes needed).

 -- Jakub Wilk <jwilk@debian.org>  Wed, 29 Oct 2014 22:54:38 +0100

socket-wrapper (1.1.1-1) experimental; urgency=low

  * New upstream release:
    + Disable incomplete address in use check in bind().
    + Add support for IP_PKTINFO in recvmsg().
    + Add support for IPV6_PKTINFO in recvmsg().
    + Add support for IP_RECVDSTADDR in recvmsg() on BSD.
    + Add support for more socket options in getsockopt().
    + Add support for bindresvport().
    + Fix rebinding on connect().
    + Fix sockaddr buffer truncation in getsockname() and getpeername().
    + Fix special cases in bind().
  * Drop libc-so.diff, applied upstream.
  * Refresh no-soname.diff.
  * Bump minimum required version of libcmocka-dev to 0.4.1.
  * Update debian/copyright.
  * Enable parallel compilation.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 16 Jun 2014 10:54:45 +0200

socket-wrapper (1.0.2-1) experimental; urgency=low

  * New upstream release.
  * Refresh patches.
  * Add patch (libc-so.diff) to use the LIBC_SO macro to discover libc SONAME.
    Thanks to Pino Toscano.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 01 Jun 2014 00:05:00 +0200

socket-wrapper (1.0.1-1) experimental; urgency=low

  * Initial release (closes: #746240).
  * libsocket_wrapper is a preloadable library. We do not support directly
    linking to it, so it doesn't need the SONAME. Add patch (no-soname.diff)
    to remove it.
  * Add Lintian override for sharedobject-in-library-directory-missing-soname.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 01 May 2014 19:05:38 +0200

## socket-wrapper 1.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 set(APPLICATION_VERSION_MAJOR "1")
 set(APPLICATION_VERSION_MINOR "1")
-set(APPLICATION_VERSION_PATCH "3")
+set(APPLICATION_VERSION_PATCH "5")
 
 set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
@@ -19,7 +19,7 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.1.3")
+set(LIBRARY_VERSION "0.1.5")
 set(LIBRARY_SOVERSION "0")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked

=== doc/CMakeLists.txt ===
install(FILES
            socket_wrapper.1
        DESTINATION
            ${MAN_INSTALL_DIR}/man1)

=== src/CMakeLists.txt ===
project(libsocket_wrapper C)

include_directories(${CMAKE_BINARY_DIR})

add_library(socket_wrapper SHARED socket_wrapper.c)

target_link_libraries(socket_wrapper ${SWRAP_REQUIRED_LIBRARIES})

install(
  TARGETS
    socket_wrapper
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

set_target_properties(
  socket_wrapper
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
)

# This needs to be at the end
if (POLICY CMP0026)
    cmake_policy(SET CMP0026 OLD)
endif()
get_target_property(SWRAP_LOCATION socket_wrapper LOCATION)
set(SOCKET_WRAPPER_LOCATION ${SWRAP_LOCATION} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,14 @@
     test_echo_tcp_connect
     test_echo_tcp_bind
     test_echo_tcp_socket_options
+    test_echo_tcp_sendmsg_recvmsg
     test_echo_tcp_write_read
     test_echo_tcp_writev_readv
     test_echo_tcp_get_peer_sock_name
     test_echo_udp_sendto_recvfrom
     test_echo_udp_send_recv
-    test_echo_udp_sendmsg_recvmsg)
+    test_echo_udp_sendmsg_recvmsg
+    test_swrap_unit)
 
 if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
     set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)

=== debian/changelog ===
socket-wrapper (1.1.5-1) unstable; urgency=low

  * New upstream release.
  * Remove reproducible-manpage.diff as applied upstream.
  * Update patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 06 Jan 2016 20:03:08 +0100

=== debian/control ===
Source: socket-wrapper
Homepage: http://cwrap.org/socket_wrapper.html
Section: devel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-buildinfo,
 cmake (>= 2.8.8-3~),
 libcmocka-dev (>= 0.4.1),
 asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
XS-Testsuite: autopkgtest
Standards-Version: 3.9.6

Package: libsocket-wrapper
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: socket wrapper library
 socket_wrapper is a preload library that makes possible to run several
 instances of the full software stack on the same machine and perform locally
 functional testing of complex network configurations. It passes all socket
 communication over unix domain sockets.

=== debian/watch ===
version=3
https://ftp.samba.org/pub/cwrap/ socket_wrapper-v?([\d.]+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## socket-wrapper 1.1.6

=== debian/changelog ===
socket-wrapper (1.1.6-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.7 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 26 Mar 2016 18:39:01 +0000

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libcmocka-dev (>= 0.4.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 
 Package: libsocket-wrapper
 Architecture: any

## socket-wrapper 1.1.7

=== debian/changelog ===
socket-wrapper (1.1.7-2) unstable; urgency=medium

  * Tighten CMocka build dependency (closes: #858885).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 28 Mar 2017 19:18:47 +0000

socket-wrapper (1.1.7-1) unstable; urgency=low

  * New upstream release.
  * Update Standards-Version to 3.9.8 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 24 May 2016 20:26:14 +0000

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,10 @@
  debhelper (>= 9),
  dh-buildinfo,
  cmake (>= 2.8.8-3~),
- libcmocka-dev (>= 0.4.1),
+ libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 
 Package: libsocket-wrapper
 Architecture: any

## socket-wrapper 1.1.8+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 set(APPLICATION_VERSION_MAJOR "1")
 set(APPLICATION_VERSION_MINOR "1")
-set(APPLICATION_VERSION_PATCH "5")
+set(APPLICATION_VERSION_PATCH "8")
 
 set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
@@ -19,7 +19,7 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.1.5")
+set(LIBRARY_VERSION "0.1.8")
 set(LIBRARY_SOVERSION "0")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked

=== src/CMakeLists.txt ===
project(libsocket_wrapper C)

include_directories(${CMAKE_BINARY_DIR})

add_library(socket_wrapper SHARED socket_wrapper.c)

target_link_libraries(socket_wrapper ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

install(
  TARGETS
    socket_wrapper
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

set_target_properties(
  socket_wrapper
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
)

set(SOCKET_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}socket_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -16,10 +16,14 @@
 add_library(${TORTURE_LIBRARY} STATIC torture.c)
 target_link_libraries(${TORTURE_LIBRARY}
     ${CMOCKA_LIBRARY}
-    ${SWRAP_REQUIRED_LIBRARIES})
+    ${SWRAP_REQUIRED_LIBRARIES}
+    ${CMAKE_THREAD_LIBS_INIT})
 
 set(SWRAP_TESTS
     test_ioctl
+    test_tcp_listen
+    test_tcp_dup2
+    test_fcntl
     test_echo_tcp_socket
     test_echo_tcp_connect
     test_echo_tcp_bind
@@ -31,7 +35,9 @@
     test_echo_udp_sendto_recvfrom
     test_echo_udp_send_recv
     test_echo_udp_sendmsg_recvmsg
-    test_swrap_unit)
+    test_swrap_unit
+    test_max_sockets
+    test_close_failure)
 
 if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
     set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)

=== debian/changelog ===
socket-wrapper (1.1.8+ds-1) unstable; urgency=medium

  * New upstream release.
  * Disable wait_more_for_server patch for now, upstream increased startup
    checking time.
  * Update Standards-Version to 4.1.1 and debhelper level to 10 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 08 Nov 2017 17:43:36 +0000

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 10),
  dh-buildinfo,
  cmake (>= 2.8.8-3~),
  libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 
 Package: libsocket-wrapper
 Architecture: any

=== debian/watch ===
version=3
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$// \
https://ftp.samba.org/pub/cwrap/ socket_wrapper-v?([\d.]+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## socket-wrapper 1.1.9+ds

=== debian/changelog ===
socket-wrapper (1.1.9+ds-1) unstable; urgency=medium

  * New upstream release (closes: #894796).
  * Update Standards-Version to 4.1.3 .
  * Update debhelper level to 11 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 04 Apr 2018 16:52:41 +0000

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11),
  dh-buildinfo,
  cmake (>= 2.8.8-3~),
  libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 
 Package: libsocket-wrapper
 Architecture: any

## socket-wrapper 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,20 @@
-project(socket_wrapper C)
+# Required cmake version
+cmake_minimum_required(VERSION 3.5.0)
+cmake_policy(SET CMP0048 NEW)
 
-# Required cmake version
-cmake_minimum_required(VERSION 2.8.5)
+# Specify search path for CMake modules to be loaded by include() 
+# and find_package()
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
+
+# Add defaults for cmake
+# Those need to be set before the project() call.
+include(DefineCMakeDefaults)
+include(DefineCompilerFlags)
+
+project(socket_wrapper VERSION 1.2.1 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
-
-set(APPLICATION_VERSION_MAJOR "1")
-set(APPLICATION_VERSION_MINOR "1")
-set(APPLICATION_VERSION_PATCH "8")
-
-set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
 # SOVERSION scheme: CURRENT.AGE.REVISION
 #   If there was an incompatible interface change:
@@ -19,21 +23,15 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.1.8")
+set(LIBRARY_VERSION "0.1.11")
 set(LIBRARY_SOVERSION "0")
 
-# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
-set(CMAKE_MODULE_PATH
-  ${CMAKE_SOURCE_DIR}/cmake/Modules
-)
-
 # add definitions
-include(DefineCMakeDefaults)
 include(DefinePlatformDefaults)
-include(DefineCompilerFlags)
 include(DefineInstallationPaths)
 include(DefineOptions.cmake)
 include(CPackConfig.cmake)
+include(CompilerChecks.cmake)
 
 # disallow in-source build
 include(MacroEnsureOutOfSourceBuild)
@@ -51,7 +49,7 @@
 add_subdirectory(src)
 
 if (UNIT_TESTING)
-    find_package(cmocka 0.4.1 REQUIRED)
+    find_package(cmocka 1.1.0 REQUIRED)
 
     include(AddCMockaTest)
     add_subdirectory(tests)

=== src/CMakeLists.txt ===
project(libsocket_wrapper C)

add_library(socket_wrapper SHARED socket_wrapper.c)
target_include_directories(socket_wrapper
                           PRIVATE
                               ${CMAKE_BINARY_DIR})
target_compile_options(socket_wrapper
                       PRIVATE
                          ${DEFAULT_C_COMPILE_FLAGS}
                          -D_GNU_SOURCE)
target_link_libraries(socket_wrapper ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

set_target_properties(socket_wrapper
                      PROPERTIES
                          VERSION ${LIBRARY_VERSION}
                          SOVERSION ${LIBRARY_SOVERSION})
if (DEFINED DEFAULT_LINK_FLAGS)
    set_target_properties(socket_wrapper
                          PROPERTIES
                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
endif()

install(
  TARGETS
    socket_wrapper
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

set(SOCKET_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}socket_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMOCKA_INCLUDE_DIR}
)

set(TORTURE_LIBRARY torture)

# RFC862 echo server
add_executable(echo_srv echo_srv.c)
target_compile_options(echo_srv
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})
if (DEFINED DEFAULT_LINK_FLAGS)
    set_target_properties(echo_srv
                          PROPERTIES
                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
endif()

add_library(${TORTURE_LIBRARY} STATIC torture.c)
target_compile_options(${TORTURE_LIBRARY}
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
target_link_libraries(${TORTURE_LIBRARY}
    ${CMOCKA_LIBRARY}
    ${SWRAP_REQUIRED_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT})

set(SWRAP_THREADED_TESTS
    test_thread_sockets
    test_thread_echo_tcp_connect
    test_thread_echo_tcp_write_read
    test_thread_echo_tcp_sendmsg_recvmsg
    test_thread_echo_udp_send_recv)

set(SWRAP_TESTS
    test_ioctl
    test_tcp_listen
    test_tcp_dup2
    test_fcntl
    test_echo_tcp_connect
    test_echo_tcp_bind
    test_echo_tcp_socket_options
    test_echo_tcp_sendmsg_recvmsg
    test_echo_tcp_write_read
    test_echo_tcp_writev_readv
    test_echo_tcp_get_peer_sock_name
    test_echo_udp_sendto_recvfrom
    test_echo_udp_send_recv
    test_echo_udp_sendmsg_recvmsg
    test_swrap_unit
    test_max_sockets
    test_close_failure
    test_tcp_socket_overwrite
    ${SWRAP_THREADED_TESTS})

if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)
endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)

function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
            find_library(ASAN_LIBRARY
                         NAMES asan)
            if (NOT ASAN_LIBRARY)
                foreach(version RANGE 10 1)
                    if (NOT ASAN_LIBRARY)
                        find_library(ASAN_LIBRARY libasan.so.${version})
                    endif()
                endforeach()
            endif()
        endif()
    endif()

    if (ASAN_LIBRARY)
        list(APPEND PRELOAD_LIBRARIES ${ASAN_LIBRARY})
    endif()
    list(APPEND PRELOAD_LIBRARIES ${SOCKET_WRAPPER_LOCATION})

    if (OSX)
        set(TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION}")
    else ()
        string(REPLACE ";" ":" _TMP_ENV "${PRELOAD_LIBRARIES}")
        set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
    endif()

    set_property(TEST
                    ${_TEST_NAME}
                PROPERTY
                    ENVIRONMENT "${TORTURE_ENVIRONMENT}")
endfunction()

foreach(_SWRAP_TEST ${SWRAP_TESTS})
    add_cmocka_test(${_SWRAP_TEST}
                    SOURCES ${_SWRAP_TEST}.c
                    COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
                    LINK_LIBRARIES ${TORTURE_LIBRARY}
                    LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
    add_cmocka_test_environment(${_SWRAP_TEST})
endforeach()

if (HELGRIND_TESTING)
    find_program(VALGRIND_EXECUTABLE valgrind)
    if (VALGRIND_EXECUTABLE)
        set(VALGRIND_HELGRIND_OPTIONS -v --trace-children=yes --tool=helgrind --error-exitcode=1 --read-var-info=yes --suppressions=${CMAKE_CURRENT_SOURCE_DIR}/helgrind.supp)

        foreach(_TEST ${SWRAP_THREADED_TESTS})
            set(_HELGRIND_TEST "helgrind_${_TEST}")

            add_test(NAME ${_HELGRIND_TEST} COMMAND ${VALGRIND_EXECUTABLE} ${VALGRIND_HELGRIND_OPTIONS} ${CMAKE_CURRENT_BINARY_DIR}/${_TEST})
            if (OSX)
                set_property(
                    TEST
                        ${_HELGRIND_TEST}
                    PROPERTY
                        ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION})
            else ()
                set_property(
                    TEST
                        ${_HELGRIND_TEST}
                    PROPERTY
                        ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION})
            endif()
        endforeach()
    endif()
endif()

# test_fork_pthread
add_library(thread_deadlock SHARED thread_deadlock.c)
target_link_libraries(thread_deadlock ${CMAKE_THREAD_LIBS_INIT})
target_compile_options(thread_deadlock PRIVATE ${DEFAULT_C_COMPILE_FLAGS})

add_cmocka_test(test_fork_thread_deadlock
                SOURCES test_fork_thread_deadlock.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
                LINK_LIBRARIES ${TORTURE_LIBRARY} thread_deadlock
                LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
add_cmocka_test_environment(test_fork_thread_deadlock)

=== debian/changelog ===
socket-wrapper (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.2.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 24 Nov 2018 19:23:39 +0000

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 
 Package: libsocket-wrapper
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

cflags = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
ldflags = $(shell dpkg-buildflags --get LDFLAGS)

cmake_options = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=None \
	-DCMAKE_C_FLAGS="$(cflags)" \
	-DCMAKE_SHARED_LINKER_FLAGS="$(ldflags)" \
	-DCMAKE_EXE_LINKER_FLAGS="$(ldflags)" \

ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
cmake_options += \
	-DUNIT_TESTING=1
endif

parallel = -j$(or $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS))),1)

.PHONY: clean
clean: debian/control
	dh_clean
	rm -rf obj

.PHONY: build build-arch build-indep
build: build-arch
build-arch: obj/stamp

obj/stamp: CMakeLists.txt
	mkdir -p obj
	cd obj && cmake $(cmake_options) ..
	$(MAKE) $(parallel) -C obj/
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	$(MAKE) -C obj/ test
endif
	a2x --doctype manpage --format manpage doc/socket_wrapper.1.txt
	touch $(@)

.PHONY: binary binary-arch binary-indep
binary: binary-arch
binary-arch: obj/stamp
	dh_testroot
	dh_prep
	$(MAKE) -C obj/ install DESTDIR=../debian/libsocket-wrapper/
	dh_lintian
	dh_installchangelogs
	dh_installdocs AUTHORS README TODO
	dh_installexamples example/*
	dh_buildinfo
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# vim:ts=4 sw=4 noet

## socket-wrapper 1.2.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,12 +20,10 @@
                               LINK_FLAGS ${DEFAULT_LINK_FLAGS})
 endif()
 
-install(
-  TARGETS
-    socket_wrapper
-  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
-  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
-  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
+install(TARGETS socket_wrapper
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
 )
 
 set(SOCKET_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}socket_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

=== debian/changelog ===
socket-wrapper (1.2.3-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.4.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Aug 2019 14:32:21 +0000

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 
 Package: libsocket-wrapper
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,10 @@
 #!/usr/bin/make -f
+# -*- makefile -*-
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+include /usr/share/dpkg/architecture.mk
 
 cflags = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
 ldflags = $(shell dpkg-buildflags --get LDFLAGS)
@@ -43,9 +49,11 @@
 	dh_testroot
 	dh_prep
 	$(MAKE) -C obj/ install DESTDIR=../debian/libsocket-wrapper/
+	# generate Lintian override per build host
+	sed -i "s|lib/\(.*\)/lib|lib/${DEB_HOST_GNU_TYPE}/lib|" debian/libsocket-wrapper.lintian-overrides
 	dh_lintian
 	dh_installchangelogs
-	dh_installdocs AUTHORS README TODO
+	dh_installdocs AUTHORS README.md TODO
 	dh_installexamples example/*
 	dh_buildinfo
 	dh_strip

## socket-wrapper 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,27 +11,30 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.2.1 LANGUAGES C)
+project(socket_wrapper VERSION 1.2.4 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
 
-# SOVERSION scheme: CURRENT.AGE.REVISION
+# SOVERSION scheme: MAJOR.MINOR.PATCH
 #   If there was an incompatible interface change:
-#     Increment CURRENT. Set AGE and REVISION to 0
+#     Increment MAJOR. Set MINOR and PATCH to 0
 #   If there was a compatible interface change:
-#     Increment AGE. Set REVISION to 0
+#     Increment MINOR. Set PATCH to 0
 #   If the source code was changed, but there were no interface changes:
-#     Increment REVISION.
-set(LIBRARY_VERSION "0.1.11")
-set(LIBRARY_SOVERSION "0")
+#     Increment PATCH.
+set(LIBRARY_VERSION_MAJOR 0)
+set(LIBRARY_VERSION_MINOR 1)
+set(LIBRARY_VERSION_PATCH 14)
+set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
+set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})
 
 # add definitions
 include(DefinePlatformDefaults)
-include(DefineInstallationPaths)
 include(DefineOptions.cmake)
 include(CPackConfig.cmake)
 include(CompilerChecks.cmake)
+include(GNUInstallDirs)
 
 # disallow in-source build
 include(MacroEnsureOutOfSourceBuild)
@@ -63,7 +66,7 @@
   FILES
     ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc
   DESTINATION
-    ${LIB_INSTALL_DIR}/pkgconfig
+      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
   COMPONENT
     pkgconfig
 )
@@ -76,7 +79,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake
         ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake
     DESTINATION
-        ${CMAKE_INSTALL_DIR}/socket_wrapper
+        ${CMAKE_INSTALL_LIBDIR}/cmake/socket_wrapper
     COMPONENT
         devel
 )

## socket-wrapper 1.2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.2.4 LANGUAGES C)
+project(socket_wrapper VERSION 1.2.5 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,7 +25,7 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 1)
-set(LIBRARY_VERSION_PATCH 14)
+set(LIBRARY_VERSION_PATCH 15)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -127,7 +127,7 @@
                     TEST
                         ${_HELGRIND_TEST}
                     PROPERTY
-                        ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION})
+                        ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION} SOCKET_WRAPPER_DISABLE_DEEPBIND=1)
             endif()
         endforeach()
     endif()

=== debian/changelog ===
socket-wrapper (1.2.5-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 01 Jul 2020 19:44:18 +0200

socket-wrapper (1.2.4-1) unstable; urgency=medium

  * New upstream release.
  * Switch to short debhelper rules format.
  * Update debhelper level to 12 .
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 16 Apr 2020 19:22:01 +0000

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
  dh-buildinfo,
  cmake (>= 2.8.8-3~),
  libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 
 Package: libsocket-wrapper
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --builddirectory=$(CURDIR)/obj/

=== debian/tests/control ===
Tests: tests
Depends: libsocket-wrapper,
 build-essential,
 cmake (>= 2.8.8-3~),
 libcmocka-dev (>= 0.4.1),
Restrictions: allow-stderr

Tests: adequate
Depends: libsocket-wrapper, adequate

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$// \
https://ftp.samba.org/pub/cwrap/ socket_wrapper-v?([\d.]+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## socket-wrapper 1.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.2.5 LANGUAGES C)
+project(socket_wrapper VERSION 1.3.3 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -24,10 +24,16 @@
 #   If the source code was changed, but there were no interface changes:
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
-set(LIBRARY_VERSION_MINOR 1)
-set(LIBRARY_VERSION_PATCH 15)
+set(LIBRARY_VERSION_MINOR 3)
+set(LIBRARY_VERSION_PATCH 0)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})
+
+set(NOOP_LIBRARY_VERSION_MAJOR 0)
+set(NOOP_LIBRARY_VERSION_MINOR 0)
+set(NOOP_LIBRARY_VERSION_PATCH 1)
+set(NOOP_LIBRARY_VERSION "${NOOP_LIBRARY_VERSION_MAJOR}.${NOOP_LIBRARY_VERSION_MINOR}.${NOOP_LIBRARY_VERSION_PATCH}")
+set(NOOP_LIBRARY_SOVERSION ${NOOP_LIBRARY_VERSION_MAJOR})
 
 # add definitions
 include(DefinePlatformDefaults)
@@ -71,6 +77,16 @@
     pkgconfig
 )
 
+configure_file(socket_wrapper_noop.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper_noop.pc @ONLY)
+install(
+  FILES
+    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper_noop.pc
+  DESTINATION
+      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
+  COMPONENT
+    pkgconfig
+)
+
 # cmake config files
 configure_file(socket_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake @ONLY)
 configure_file(socket_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake @ONLY)

=== debian/changelog ===
socket-wrapper (1.3.3-1) unstable; urgency=medium

  * New upstream release (closes: #1008923).
  * Add libsocket_wrapper_noop.so to the binary package.
  * Update watch file.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.6.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 20 Oct 2021 18:09:43 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-buildinfo,
  cmake (>= 2.8.8-3~),
  libcmocka-dev (>= 1.0.1),
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
 XS-Testsuite: autopkgtest
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 
 Package: libsocket-wrapper
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,4 +5,4 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@ --builddirectory=$(CURDIR)/obj/
+	dh $@  --buildsystem=cmake --builddirectory=$(CURDIR)/obj/

## socket-wrapper 1.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 3.5.0)
 cmake_policy(SET CMP0048 NEW)
 
-# Specify search path for CMake modules to be loaded by include() 
+# Specify search path for CMake modules to be loaded by include()
 # and find_package()
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.3.3 LANGUAGES C)
+project(socket_wrapper VERSION 1.3.4 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,7 +25,7 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 3)
-set(LIBRARY_VERSION_PATCH 0)
+set(LIBRARY_VERSION_PATCH 1)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== debian/changelog ===
socket-wrapper (1.3.4-1) unstable; urgency=medium

  * New upstream release.
  * Enable unit testing.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 31 Jul 2022 11:05:45 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,8 @@
  dh-buildinfo,
  cmake (>= 2.8.8-3~),
  libcmocka-dev (>= 1.0.1),
- asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl
+ asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl,
+ libcmocka-dev <!nocheck>
 XS-Testsuite: autopkgtest
 Standards-Version: 4.6.0

## socket-wrapper 1.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.3.4 LANGUAGES C)
+project(socket_wrapper VERSION 1.3.5 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,7 +25,7 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 3)
-set(LIBRARY_VERSION_PATCH 1)
+set(LIBRARY_VERSION_PATCH 2)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,8 @@
                        PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
-target_link_libraries(socket_wrapper ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
+target_link_libraries(socket_wrapper
+                      PRIVATE ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
 
 set_target_properties(socket_wrapper
                       PROPERTIES
@@ -27,3 +28,43 @@
 )
 
 set(SOCKET_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}socket_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)
+
+add_library(socket_wrapper_noop SHARED socket_wrapper_noop.c)
+target_include_directories(socket_wrapper_noop
+                           PRIVATE
+                               ${socket_wrapper_BINARY_DIR}
+                           PUBLIC
+                               $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+                               $<INSTALL_INTERFACE:include>)
+target_compile_options(socket_wrapper_noop
+                       PRIVATE
+                          ${DEFAULT_C_COMPILE_FLAGS}
+                          -D_GNU_SOURCE)
+target_link_libraries(socket_wrapper_noop
+                      PRIVATE ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
+set_target_properties(socket_wrapper_noop
+                      PROPERTIES
+                          VERSION ${NOOP_LIBRARY_VERSION}
+                          SOVERSION ${NOOP_LIBRARY_SOVERSION})
+if (DEFINED DEFAULT_LINK_FLAGS)
+    set_target_properties(socket_wrapper_noop
+                          PROPERTIES
+                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
+endif()
+
+install(TARGETS socket_wrapper_noop
+        EXPORT socket_wrapper_noop-config
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+)
+
+install(EXPORT socket_wrapper_noop-config
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/socket_wrapper)
+
+install(
+    FILES
+        ${CMAKE_CURRENT_SOURCE_DIR}/socket_wrapper.h
+    DESTINATION
+        ${CMAKE_INSTALL_INCLUDEDIR}
+)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -56,12 +56,13 @@
     test_echo_udp_sendmsg_recvmsg
     test_swrap_unit
     test_max_sockets
+    test_public_functions
     test_close_failure
     test_tcp_socket_overwrite
     ${SWRAP_THREADED_TESTS})
 
 if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
-    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)
+    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd test_echo_tcp_sendmsg_recvmsg_fd)
 endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
 
 function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
@@ -92,6 +93,15 @@
         set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
     endif()
 
+    if (CMAKE_BUILD_TYPE)
+        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
+        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer" OR
+            CMAKE_BUILD_TYPE_LOWER STREQUAL "threadsanitizer" OR
+            CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
+            list(APPEND TORTURE_ENVIRONMENT "SOCKET_WRAPPER_DISABLE_DEEPBIND=1")
+        endif()
+    endif()
+
     set_property(TEST
                     ${_TEST_NAME}
                 PROPERTY
@@ -102,7 +112,7 @@
     add_cmocka_test(${_SWRAP_TEST}
                     SOURCES ${_SWRAP_TEST}.c
                     COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
-                    LINK_LIBRARIES ${TORTURE_LIBRARY}
+                    LINK_LIBRARIES ${TORTURE_LIBRARY} socket_wrapper_noop
                     LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
     add_cmocka_test_environment(${_SWRAP_TEST})
 endforeach()

=== debian/changelog ===
socket-wrapper (1.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.6.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 07 Jan 2023 20:51:24 +0100

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,11 @@
  asciidoc, libxml2-utils, xsltproc, docbook-xml, docbook-xsl,
  libcmocka-dev <!nocheck>
 XS-Testsuite: autopkgtest
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 
 Package: libsocket-wrapper
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: socket wrapper library
  socket_wrapper is a preload library that makes possible to run several

=== debian/rules ===
--- 
+++ 
@@ -4,5 +4,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DUNIT_TESTING=1
+
 %:
 	dh $@  --buildsystem=cmake --builddirectory=$(CURDIR)/obj/
+
+.PHONY: override_dh_auto_configure

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
pgpsigurlmangle=s/$/.asc/
https://ftp.samba.org/pub/cwrap/ \
socket_wrapper-v?(\d\S*)@ARCHIVE_EXT@
